/*=============================================================================
	Copyright (c) 1999-2003 pmG Worldwide, LLC.

	File:	messiah_arg.h
	Author:	Lyle Milton
	Date:	01/01/03

		last modified: 2/04/03 - LM

=============================================================================*/


#ifdef _MESSIAH_API_ARG


#ifndef	__MESSIAH_ARG
#define __MESSIAH_ARG


#ifndef	__MESSIAH_HIDE_TYPES

	//Argument Types,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
	#define FX_ARG_TIME				0
	#define FX_ARG_FRAME			1
	#define FX_ARG_DOUBLE			2
	#define FX_ARG_VECTORD3			3
	#define FX_ARG_VECTORD4			4

	#define FX_ARG_CHAR				5
	#define FX_ARG_STRING			6
	#define FX_ARG_RGB				7
	#define FX_ARG_RGBA				8

	#define FX_ARG_INT				9
	#define FX_ARG_CHANNEL_INT		10

	#define FX_ARG_OBJECT			11

	#define FX_ARG_VOID				14
	#define FX_ARG_POINTER			FX_ARG_VOID

	#define FX_ARG_POINTER_INT		20
	#define FX_ARG_POINTER_DOUBLE	21
	#define FX_ARG_POINTER_FLOAT	22
	#define FX_ARG_POINTER_STRING	23
	#define FX_ARG_POINTER_CHAR		24

	#define FX_ARG_STRING_LIST		25

	#define FX_ARG_DOUBLEPOINTER	26
	#define FX_ARG_TRIPLEPOINTER	27

	#define FX_ARG_FLOAT			28

	#define FX_ARG_VECTORF3			29
	#define FX_ARG_VECTORF4			30
	#define FX_ARG_VECTORI3			31
	#define FX_ARG_VECTORI4			32

	#define FX_ARG_INT64			33

	//#define FX_ARG_STRING_CONST		34

	#define FX_ARG_IMAGE			36


	//for use with fxArgSave*-------------------------------------------
	#define FX_ARGDATA_COPY_NAME	(1<<28)
	//NOTE: When saving data, it may sometimes be necessary to use a single string
	//pointer to name your data.
	//
	//For example, while it's most common to use string constants for name:
	//
	//		fxArgSaveFloat(ai, "MyWeightValue", my_value, 0);
	//
	//it may be sometimes necessary to save an array of data which would require
	//that you construct a unique name for each element. In which case, you'll
	//need the name to be copied into the arg:
	//
	//		for (i=0;i<num_elements;i++)
	//		{
	//			sprintf(name, "%s%d", "MyWeightValue", i);
	//
	//			fxArgSaveFloat(ai, name, my_value[i], FX_ARGDATA_COPY_NAME);
	//		}
	//`````````````````````````````````````````````````````````````````````````


#endif	//__MESSIAH_HIDE_TYPES



FX_API(FX_Format*, fxFormatNew)(FX_AccessInfo *ai, FXchar *name, FXint flags);

FX_API(FX_Format*, fxFormatGet)(FX_AccessInfo *ai, FXchar *name);

FX_API(FX_Format*, fxFormatNext)(FX_AccessInfo *ai, FX_Format *next);

FX_API(FX_Format*, fxFormatPrev)(FX_AccessInfo *ai, FX_Format *prev);

FX_API(FXvoid, fxArgResetLoad)(FXvoid *args);


//GET Value--------------------------------------------------------------------
FX_API(FXint, fxArgGetInt)(FXvoid *args, FXchar *name, FXint ID, FXint *var);

FX_API(FXint, fxArgGetDouble)(FXvoid *args, FXchar *name, FXint ID, FXdouble *var);

FX_API(FXint, fxArgGetFloat)(FXvoid *args, FXchar *name, FXint ID, FXfloat *var);

FX_API(FXint, fxArgGetVeci3)(FXvoid *args, FXchar *name, FXint ID, FXveci var);

FX_API(FXint, fxArgGetVecd3)(FXvoid *args, FXchar *name, FXint ID, FXvecd var);

FX_API(FXint, fxArgGetVecf3)(FXvoid *args, FXchar *name, FXint ID, FXvecf var);

FX_API(FXint, fxArgGetVeci4)(FXvoid *args, FXchar *name, FXint ID, FXveci4 var);

FX_API(FXint, fxArgGetVecd4)(FXvoid *args, FXchar *name, FXint ID, FXvecd4 var);

FX_API(FXint, fxArgGetVecf4)(FXvoid *args, FXchar *name, FXint ID, FXvecf4 var);

FX_API(FXint, fxArgGetCharRGB)(FXvoid *args, FXchar *name, FXint ID, FXchar *var);

FX_API(FXint, fxArgGetCharRGBA)(FXvoid *args, FXchar *name, FXint ID, FXchar *var);

FX_API(FXint, fxArgGetChar)(FXvoid *args, FXchar *name, FXint ID, FXchar *var);

FX_API(FXint, fxArgGetString)(FXvoid *args, FXchar *name, FXint ID, FXchar *var, FXint buffer_length);

FX_API(FXint, fxArgGetObj)(FXvoid *args, FXchar *name, FXint ID, FXobject *var);

FX_API(FXint, fxArgGetImage)(FXvoid *args, FXchar *name, FXint ID, FXimage *var);

FX_API(FXint, fxArgGetVoid)(FXvoid *args, FXchar *name, FXint ID, FXvoid **var);

FX_API(FXint, fxArgGetInt64)(FXvoid *args, FXchar *name, FXint ID, FXint64 *var);
//`````````````````````````````````````````````````````````````````````````````




//SET Value--------------------------------------------------------------------
FX_API(FXint, fxArgSetInt)(FXvoid *args, FXchar *name, FXint ID, FXint var);

FX_API(FXint, fxArgSetDouble)(FXvoid *args, FXchar *name, FXint ID, FXdouble var);

FX_API(FXint, fxArgSetFloat)(FXvoid *args, FXchar *name, FXint ID, FXfloat var);

FX_API(FXint, fxArgSetVeci3)(FXvoid *args, FXchar *name, FXint ID, FXveci var);

FX_API(FXint, fxArgSetVecd3)(FXvoid *args, FXchar *name, FXint ID, FXvecd var);

FX_API(FXint, fxArgSetVecf3)(FXvoid *args, FXchar *name, FXint ID, FXvecf var);

FX_API(FXint, fxArgSetVeci4)(FXvoid *args, FXchar *name, FXint ID, FXveci4 var);

FX_API(FXint, fxArgSetVecd4)(FXvoid *args, FXchar *name, FXint ID, FXvecd4 var);

FX_API(FXint, fxArgSetVecf4)(FXvoid *args, FXchar *name, FXint ID, FXvecf4 var);

FX_API(FXint, fxArgSetCharRGB)(FXvoid *args, FXchar *name, FXint ID, FXchar *var);

FX_API(FXint, fxArgSetCharRGBA)(FXvoid *args, FXchar *name, FXint ID, FXchar *var);

FX_API(FXint, fxArgSetChar)(FXvoid *args, FXchar *name, FXint ID, FXchar var);

FX_API(FXint, fxArgSetString)(FXvoid *args, FXchar *name, FXint ID, FXchar *var);

FX_API(FXint, fxArgSetObj)(FXvoid *args, FXchar *name, FXint ID, FXobject var);

FX_API(FXint, fxArgSetImage)(FXvoid *args, FXchar *name, FXint ID, FXimage var);

FX_API(FXint, fxArgSetVoid)(FXvoid *args, FXchar *name, FXint ID, FXvoid *var);

FX_API(FXint, fxArgSetInt64)(FXvoid *args, FXchar *name, FXint ID, FXint64 var);
//`````````````````````````````````````````````````````````````````````````````





//LOAD Value-------------------------------------------------------------------
FX_API(FXint, fxArgLoadInt)(FXvoid *args, FXchar *name, FXint *var);

FX_API(FXint, fxArgLoadDouble)(FXvoid *args, FXchar *name, FXdouble *var);

FX_API(FXint, fxArgLoadFloat)(FXvoid *args, FXchar *name, FXfloat *var);

FX_API(FXint, fxArgLoadVeci3)(FXvoid *args, FXchar *name, FXveci var);

FX_API(FXint, fxArgLoadVecd3)(FXvoid *args, FXchar *name, FXvecd var);

FX_API(FXint, fxArgLoadVecf3)(FXvoid *args, FXchar *name, FXvecf var);

FX_API(FXint, fxArgLoadVeci4)(FXvoid *args, FXchar *name, FXveci4 var);

FX_API(FXint, fxArgLoadVecd4)(FXvoid *args, FXchar *name, FXvecd4 var);

FX_API(FXint, fxArgLoadVecf4)(FXvoid *args, FXchar *name, FXvecf4 var);

FX_API(FXint, fxArgLoadCharRGB)(FXvoid *args, FXchar *name, FXchar *var);

FX_API(FXint, fxArgLoadCharRGBA)(FXvoid *args, FXchar *name, FXchar *var);

FX_API(FXint, fxArgLoadChar)(FXvoid *args, FXchar *name, FXchar *var);

FX_API(FXint, fxArgLoadString)(FXvoid *args, FXchar *name, FXchar *var, FXint buffer_length);

FX_API(FXint, fxArgLoadObj)(FXvoid *args, FXchar *name, FXobject *var);

FX_API(FXint, fxArgLoadImage)(FXvoid *args, FXchar *name, FXimage *var);

FX_API(FXint, fxArgLoadVoid)(FXvoid *args, FXchar *name, FXvoid **var);

FX_API(FXint, fxArgLoadInt64)(FXvoid *args, FXchar *name, FXint64 *var);

FX_API(FXint, fxArgLoadWeight)(FXvoid *args, FXchar *name, FXveci var);
//`````````````````````````````````````````````````````````````````````````````





//SAVE Value-------------------------------------------------------------------
FX_API(FXint, fxArgSaveInt)(FXvoid *args, FXchar *name, FXint var, FXint flags);

FX_API(FXint, fxArgSaveDouble)(FXvoid *args, FXchar *name, FXdouble var, FXint flags);

FX_API(FXint, fxArgSaveFloat)(FXvoid *args, FXchar *name, FXfloat var, FXint flags);

FX_API(FXint, fxArgSaveVeci3)(FXvoid *args, FXchar *name, FXveci var, FXint flags);

FX_API(FXint, fxArgSaveVecd3)(FXvoid *args, FXchar *name, FXvecd var, FXint flags);

FX_API(FXint, fxArgSaveVecf3)(FXvoid *args, FXchar *name, FXvecf var, FXint flags);

FX_API(FXint, fxArgSaveVeci4)(FXvoid *args, FXchar *name, FXveci4 var, FXint flags);

FX_API(FXint, fxArgSaveVecd4)(FXvoid *args, FXchar *name, FXvecd4 var, FXint flags);

FX_API(FXint, fxArgSaveVecf4)(FXvoid *args, FXchar *name, FXvecf4 var, FXint flags);

FX_API(FXint, fxArgSaveCharRGB)(FXvoid *args, FXchar *name, FXchar *var, FXint flags);

FX_API(FXint, fxArgSaveCharRGBA)(FXvoid *args, FXchar *name, FXchar *var, FXint flags);

FX_API(FXint, fxArgSaveChar)(FXvoid *args, FXchar *name, FXchar var, FXint flags);

FX_API(FXint, fxArgSaveString)(FXvoid *args, FXchar *name, FXchar *var, FXint flags);

FX_API(FXint, fxArgSaveObj)(FXvoid *args, FXchar *name, FXobject var, FXint flags);

FX_API(FXint, fxArgSaveImage)(FXvoid *args, FXchar *name, FXimage var, FXint flags);

FX_API(FXint, fxArgSaveVoid)(FXvoid *args, FXchar *name, FXvoid *var, FXint flags);

FX_API(FXint, fxArgSaveInt64)(FXvoid *args, FXchar *name, FXint64 var, FXint flags);

FX_API(FXint, fxArgSaveWeight)(FXvoid *args, FXchar *name, FXveci var, FXint flags);
//`````````````````````````````````````````````````````````````````````````````

//Custom Processing
// message retreving from args for custom processing at E_PROCESS
//returns the object or effect that sent the message
FX_API(FXobject, fxProcess_GetSender)(FX_AccessInfo *ai);

// extract the message so you can see what it is
FX_API(FXint, fxProcess_GetMessage)(FX_AccessInfo *ai,FXchar *message);

//compares the message sent to a string you provide
FX_API(FXint, fxProcess_CompareMessage)(FX_AccessInfo *ai,FXchar *message);

//writes a reply string you provide back to the sending object
FX_API(FXint, fxProcess_SendReplyFlags)(FX_AccessInfo *ai,FXint reply_flags);
////////////////////////


#define _MESSIAH_PTR_ARG	messiah_apicomponent = FX_APIFUNCS_ARG;\
							FX_PTR(fxFormatNew);\
							FX_PTR(fxFormatGet);\
							FX_PTR(fxFormatNext);\
							FX_PTR(fxFormatPrev);\
							\
							FX_PTR(fxArgResetLoad);\
							\
							FX_PTR(fxArgGetInt);\
							FX_PTR(fxArgGetDouble);\
							FX_PTR(fxArgGetFloat);\
							FX_PTR(fxArgGetVeci3);\
							FX_PTR(fxArgGetVecd3);\
							FX_PTR(fxArgGetVecf3);\
							FX_PTR(fxArgGetVeci4);\
							FX_PTR(fxArgGetVecd4);\
							FX_PTR(fxArgGetVecf4);\
							FX_PTR(fxArgGetCharRGB);\
							FX_PTR(fxArgGetCharRGBA);\
							FX_PTR(fxArgGetChar);\
							FX_PTR(fxArgGetString);\
							FX_PTR(fxArgGetObj);\
							FX_PTR(fxArgGetImage);\
							FX_PTR(fxArgGetVoid);\
							FX_PTR(fxArgGetInt64);\
							\
							FX_PTR(fxArgSetInt);\
							FX_PTR(fxArgSetDouble);\
							FX_PTR(fxArgSetFloat);\
							FX_PTR(fxArgSetVeci3);\
							FX_PTR(fxArgSetVecd3);\
							FX_PTR(fxArgSetVecf3);\
							FX_PTR(fxArgSetVeci4);\
							FX_PTR(fxArgSetVecd4);\
							FX_PTR(fxArgSetVecf4);\
							FX_PTR(fxArgSetCharRGB);\
							FX_PTR(fxArgSetCharRGBA);\
							FX_PTR(fxArgSetChar);\
							FX_PTR(fxArgSetString);\
							FX_PTR(fxArgSetObj);\
							FX_PTR(fxArgSetImage);\
							FX_PTR(fxArgSetVoid);\
							FX_PTR(fxArgSetInt64);\
							\
							FX_PTR(fxArgLoadInt);\
							FX_PTR(fxArgLoadDouble);\
							FX_PTR(fxArgLoadFloat);\
							FX_PTR(fxArgLoadVeci3);\
							FX_PTR(fxArgLoadVecd3);\
							FX_PTR(fxArgLoadVecf3);\
							FX_PTR(fxArgLoadVeci4);\
							FX_PTR(fxArgLoadVecd4);\
							FX_PTR(fxArgLoadVecf4);\
							FX_PTR(fxArgLoadCharRGB);\
							FX_PTR(fxArgLoadCharRGBA);\
							FX_PTR(fxArgLoadChar);\
							FX_PTR(fxArgLoadString);\
							FX_PTR(fxArgLoadObj);\
							FX_PTR(fxArgLoadImage);\
							FX_PTR(fxArgLoadVoid);\
							FX_PTR(fxArgLoadInt64);\
							FX_PTR(fxArgLoadWeight);\
							\
							FX_PTR(fxArgSaveInt);\
							FX_PTR(fxArgSaveDouble);\
							FX_PTR(fxArgSaveFloat);\
							FX_PTR(fxArgSaveVeci3);\
							FX_PTR(fxArgSaveVecd3);\
							FX_PTR(fxArgSaveVecf3);\
							FX_PTR(fxArgSaveVeci4);\
							FX_PTR(fxArgSaveVecd4);\
							FX_PTR(fxArgSaveVecf4);\
							FX_PTR(fxArgSaveCharRGB);\
							FX_PTR(fxArgSaveCharRGBA);\
							FX_PTR(fxArgSaveChar);\
							FX_PTR(fxArgSaveString);\
							FX_PTR(fxArgSaveObj);\
							FX_PTR(fxArgSaveImage);\
							FX_PTR(fxArgSaveVoid);\
							FX_PTR(fxArgSaveInt64);\
							FX_PTR(fxArgSaveWeight);\
							\
							FX_PTR(fxProcess_GetSender);\
							FX_PTR(fxProcess_GetMessage);\
							FX_PTR(fxProcess_CompareMessage);\
							FX_PTR(fxProcess_SendReplyFlags)



#endif	//__MESSIAH_ARG


#endif	//_MESSIAH_API_ARG



