/*=============================================================================
	Copyright (c) 1999-2003 pmG Worldwide, LLC.

	File:	messiah_command.h
	Author:	Lyle Milton
	Date:	01/01/03

		last modified: 2/04/03 - LM

=============================================================================*/

#ifdef _MESSIAH_API_COMMAND


#ifndef	__MESSIAH_COM
#define __MESSIAH_COM


#ifndef	__MESSIAH_HIDE_TYPES

	//Command classes - for use with fxCommandRegister
	#define FX_COMCLASS_GENERAL		"General"
	#define FX_COMCLASS_FILE		"File"
	#define FX_COMCLASS_MOTION		"Motion"
	#define FX_COMCLASS_IK			"IK"
	#define FX_COMCLASS_OBJECT		"Object"
	#define FX_COMCLASS_TOOL		"Tool"
	#define FX_COMCLASS_EFFECT		"Effect"
	#define FX_COMCLASS_SHADER		"Shader"
	#define FX_COMCLASS_SETUP		"Setup"
	#define FX_COMCLASS_RENDER		"Render"
	#define FX_COMCLASS_PLAY		"Play"
	#define FX_COMCLASS_COMMAND		"Command"
	#define FX_COMCLASS_COMPOSE		"Compose"
	#define FX_COMCLASS_INTERFACE	"Interface"
	#define FX_COMCLASS_ARMATURE	"Armature"


#endif	//__MESSIAH_HIDE_TYPES


FX_API(FXcommand, fxCommandRegister)(FXchar *name, FXchar *command_class, FXchar *command, FXint flags);

FX_API(FXcommand, fxCommandFind)(FXchar *command_name, int flags);

FX_API(FXint, fxCommandExecute)(FXcommand command, FXchar *command_name, FXint flags);

FX_API(FXint, fxExpressionCompute)(FXchar *exp, FXint flags);

FX_API(FXint, fxExpComputeInt)(FXchar *exp, FXint *var);

FX_API(FXint, fxExpComputeDouble)(FXchar *exp, FXdouble *var);

FX_API(FXint, fxExpComputeFloat)(FXchar *exp, FXfloat *var);

FX_API(FXint, fxExpComputeVeci3)(FXchar *exp, FXveci var);

FX_API(FXint, fxExpComputeVecd3)(FXchar *exp, FXvecd var);

FX_API(FXint, fxExpComputeVecf3)(FXchar *exp, FXvecf var);

FX_API(FXint, fxExpComputeVeci4)(FXchar *exp, FXveci4 var);

FX_API(FXint, fxExpComputeVecd4)(FXchar *exp, FXvecd4 var);

FX_API(FXint, fxExpComputeVecf4)(FXchar *exp, FXvecf4 var);

FX_API(FXint, fxExpComputeCharRGB)(FXchar *exp, FXchar *var);

FX_API(FXint, fxExpComputeCharRGBA)(FXchar *exp, FXchar *var);

FX_API(FXint, fxExpComputeChar)(FXchar *exp, FXchar *var);

FX_API(FXint, fxExpComputeString)(FXchar *exp, FXchar *var, FXint buffer_length);

FX_API(FXint, fxExpComputeObj)(FXchar *exp, FXobject *var);

FX_API(FXint, fxExpComputeImage)(FXchar *exp, FXimage *var);

FX_API(FXint, fxExpComputeVoid)(FXchar *exp, FXvoid **var);

FX_API(FXint, fxExpComputeInt64)(FXchar *exp, FXint64 *var);


#define _MESSIAH_PTR_COMMAND	messiah_apicomponent = FX_APIFUNCS_COMMAND;\
								FX_PTR(fxCommandRegister);\
								FX_PTR(fxCommandFind);\
								FX_PTR(fxCommandExecute);\
								FX_PTR(fxExpressionCompute);\
								FX_PTR(fxExpComputeInt);\
								FX_PTR(fxExpComputeDouble);\
								FX_PTR(fxExpComputeFloat);\
								FX_PTR(fxExpComputeVeci3);\
								FX_PTR(fxExpComputeVecd3);\
								FX_PTR(fxExpComputeVecf3);\
								FX_PTR(fxExpComputeVeci4);\
								FX_PTR(fxExpComputeVecd4);\
								FX_PTR(fxExpComputeVecf4);\
								FX_PTR(fxExpComputeCharRGB);\
								FX_PTR(fxExpComputeCharRGBA);\
								FX_PTR(fxExpComputeChar);\
								FX_PTR(fxExpComputeString);\
								FX_PTR(fxExpComputeObj);\
								FX_PTR(fxExpComputeImage);\
								FX_PTR(fxExpComputeVoid);\
								FX_PTR(fxExpComputeInt64)

#endif	//__MESSIAH_COM


#endif	//_MESSIAH_API_COMMAND

