/*=============================================================================
	Copyright (c) 1999-2003 pmG Worldwide, LLC.

	File:	messiah_main.h
	Author:	Lyle Milton
	Date:	01/01/03

		last modified: 06/10/04 - LM
			- messiah_utility.h

=============================================================================*/


#ifndef _MESSIAH_MAIN
#define _MESSIAH_MAIN


#include "messiah_version.h"



//messiah Base/Types & Access--------------------------------------------------
#include "messiah_system.h"
#include "messiah_base.h"
#include "messiah_math.h"
#include "messiah_access.h"

#define	FX_TRUE					1
#define	FX_FALSE				0

#define	FX_YES					1
#define	FX_NO					0

#define	FX_NOFLAG				0

//`````````````````````````````````````````````````````````````````````````````



//API Defines & Plugin Setup---------------------------------------------------
#include "messiah_plugin.h"
//`````````````````````````````````````````````````````````````````````````````



//API Function Components------------------------------------------------------
#ifdef _MESSIAH_FULL_API
	#define _MESSIAH_API_OBJECT
	#define _MESSIAH_API_MESH
	#define _MESSIAH_API_MOTION
	#define _MESSIAH_API_INTERFACE
	#define _MESSIAH_API_EFFECT
	#define _MESSIAH_API_SHADER
//	#define _MESSIAH_API_IMAGE		//not currently published
	#define _MESSIAH_API_FUNCTION
	#define _MESSIAH_API_COMMAND
	#define _MESSIAH_API_MESSAGE
	#define _MESSIAH_API_ARG
	#define _MESSIAH_API_DATA
//	#define _MESSIAH_API_FILE		//not currently published
//	#define _MESSIAH_API_STRING		//not currently published
	#define _MESSIAH_API_TIME
	#define _MESSIAH_API_MODULE
	#define _MESSIAH_API_EXPFUNC
	#define _MESSIAH_API_VARIABLE
	#define _MESSIAH_API_GROUP
	#define _MESSIAH_API_ARMATURE
	#define _MESSIAH_API_ACTION
#else
	#define _MESSIAH_API_MESSAGE

	#ifdef _MESSIAH_API_FUNCTION
		#ifndef _MESSIAH_API_ARG
			#define _MESSIAH_API_ARG
		#endif
	#endif

	#ifdef _MESSIAH_API_EFFECT
		#ifndef _MESSIAH_API_BASEOBJECT
			#define _MESSIAH_API_BASEOBJECT
		#endif
	#endif

	#ifdef _MESSIAH_API_SHADER
		#ifndef _MESSIAH_API_BASEOBJECT
			#define _MESSIAH_API_BASEOBJECT
		#endif
	#endif

	#ifdef _MESSIAH_API_BASEOBJECT

		#ifndef _MESSIAH_API_OBJECT
			#define _MESSIAH_API_OBJECT
		#endif
		#ifndef _MESSIAH_API_MESH
			#define _MESSIAH_API_MESH
		#endif
		#ifndef _MESSIAH_API_MOTION
			#define _MESSIAH_API_MOTION
		#endif
		#ifndef _MESSIAH_API_INTERFACE
			#define _MESSIAH_API_INTERFACE
		#endif
		#ifndef _MESSIAH_API_ARG
			#define _MESSIAH_API_ARG
		#endif
		#ifndef _MESSIAH_API_DATA
			#define _MESSIAH_API_DATA
		#endif
		#ifndef _MESSIAH_API_MODULE
			#define _MESSIAH_API_MODULE
		#endif
		#ifndef _MESSIAH_API_INTERFACE
			#define _MESSIAH_API_INTERFACE
		#endif
		#ifndef _MESSIAH_API_TIME
			#define _MESSIAH_API_TIME
		#endif

	#endif
#endif




#ifdef _MESSIAH_API_OBJECT
	#include "messiah_object.h"
#endif

#ifdef _MESSIAH_API_MESH
	#include "messiah_mesh.h"
#endif

#ifdef _MESSIAH_API_MOTION
	#include "messiah_motion.h"
#endif

#ifdef _MESSIAH_API_INTERFACE
	#include "messiah_interface.h"
#endif

#ifdef _MESSIAH_API_EFFECT
	#include "messiah_effect.h"
#endif

#ifdef _MESSIAH_API_SHADER
	#include "messiah_shader.h"
#endif

#ifdef _MESSIAH_API_IMAGE
	#include "messiah_image.h"
#endif

#ifdef _MESSIAH_API_FUNCTION
	#include "messiah_function.h"
#endif

#ifdef _MESSIAH_API_COMMAND
	#include "messiah_command.h"
#endif

#ifdef _MESSIAH_API_MESSAGE
	#include "messiah_message.h"
#endif

#ifdef _MESSIAH_API_ARG
	#include "messiah_arg.h"
#endif

#ifdef _MESSIAH_API_DATA
	#include "messiah_data.h"
#endif

#ifdef _MESSIAH_API_FILE
	#include "messiah_file.h"
#endif

#ifdef _MESSIAH_API_STRING
	#include "messiah_string.h"
#endif

#ifdef _MESSIAH_API_TIME
	#include "messiah_time.h"
#endif

#ifdef _MESSIAH_API_MODULE
	#include "messiah_module.h"
#endif

#ifdef _MESSIAH_API_EXPFUNC
	#include "messiah_expfunc.h"
#endif

#ifdef _MESSIAH_API_VARIABLE
	#include "messiah_variable.h"
#endif

#ifdef _MESSIAH_API_GROUP
	#include "messiah_group.h"
#endif

#ifdef _MESSIAH_API_ARMATURE
	#include "messiah_armature.h"
#endif

#ifdef _MESSIAH_API_ACTION
	#include "messiah_action.h"
#endif

#ifdef _MESSIAH_API_WEIGHTTOOL
	#include "messiah_weighttool.h"
#endif

#ifdef _MESSIAH_API_UTILITY
	#include "messiah_utility.h"
#endif

#ifdef _MESSIAH_API_SKELETON
	#include "messiah_tool_skeleton.h"
#endif

#ifdef _MESSIAH_API_LIGHT
	#include "messiah_tool_light.h"
#endif



FX_API(FXvoid*,	fxGetAPIFunc)(FXchar *global_name, FXint global_type);
FX_API(FXint,	fxVersion)(FXint version, FXint flags);

//`````````````````````````````````````````````````````````````````````````````



//pluginGetAPIComponents Declaration/Definition------------------------------------------
#include "messiah_getapifunc.h"
//`````````````````````````````````````````````````````````````````````````````


#endif //_MESSIAH_MAIN
