/*=============================================================================
	Copyright (c) 1999-2003 pmG Worldwide, LLC.

	File:	messiah_message.h
	Author:	Lyle Milton
	Date:	01/01/03

		last modified: 2/04/03 - LM

=============================================================================*/


#ifdef _MESSIAH_API_MESSAGE

#ifndef	__MESSIAH_MESSAGE
#define __MESSIAH_MESSAGE



#ifndef	__MESSIAH_HIDE_TYPES

	//return values from message box
	#define FX_MESSAGE_NO			0
	#define FX_MESSAGE_YES			(1<<0)
	#define FX_MESSAGE_CANCEL		(1<<1)

	//dual flag: return value from message box and flag for message box buttons
	#define FX_MESSAGE_OK			(1<<2)

	//flags for message box buttons
	#define FX_MESSAGE_OKCANCEL		(1<<3)
	#define FX_MESSAGE_YESNO		(1<<4)
	#define FX_MESSAGE_YESNOCANCEL	(1<<5)

	//message types
	#define FX_MESSAGE_INFO			(1<<6)
	#define FX_MESSAGE_WARNING		(1<<7)
	#define FX_MESSAGE_ERROR		(1<<8)
	#define FX_MESSAGE_QUESTION		(1<<9)

	//message directives
	#define FX_MESSAGE_POST			(1<<10) //post message box
	#define FX_MESSAGE_NOPORT		(1<<11) //don't print to the message port on the main window
	#define FX_MESSAGE_NOLOG		(1<<12) //don't print to the log file

	//update message port right now
	#define FX_MESSAGE_IMMEDIATE	(1<<16)

#endif	//__MESSIAH_HIDE_TYPES


FX_API(FXint, fxMessageSend)(FXentity ID, FXchar *title, FXint flags, FXchar *message, FXchar *description);
FX_API(FXint, fxMessageProgress)(FXentity ID, FXint progress, FXint flags, FXchar *message);

#define _MESSIAH_PTR_MESSAGE	messiah_apicomponent = FX_APIFUNCS_MESSAGE;\
								FX_PTR(fxMessageSend);\
								FX_PTR(fxMessageProgress)


#endif //__MESSIAH_MESSAGE

#endif //_MESSIAH_API_MESSAGE

