/*=============================================================================
	Copyright (c) 1999-2003 pmG Worldwide, LLC.

	File:	messiah_data.h
	Author:	Lyle Milton
	Date:	04/26/03

	------------------------------------------------------------



=============================================================================*/

#ifdef _MESSIAH_API_VARIABLE


#ifndef __MESSIAH_VARIABLE
#define __MESSIAH_VARIABLE


#ifndef __MESSIAH_HIDE_TYPES

#endif //__MESSIAH_HIDE_TYPES



FX_API(FXvariable, fxVarCreate)(FXchar *name, FXvariable parent, FXint flags);

FX_API(FXint, fxVarDelete)(FXvariable, FXint flags);

FX_API(FXint, fxVarName)(FXvariable, FXchar *buffer, FXint buffer_length, FXint flags);

FX_API(FXint, fxVarRename)(FXvariable, FXchar *name, FXint flags);

FX_API(FXint, fxVarExp)(FXvariable, FXchar *buffer, FXint buffer_length, FXint flags);

FX_API(FXint, fxVarExpLength)(FXvariable);

FX_API(FXint, fxVarExpSet)(FXvariable, FXchar *exp, FXint flags);

FX_API(FXint, fxVarChannelAdd)(FXvariable, FXobject, FXint channel, FXint op, FXint *ID, FXint flags);

FX_API(FXint, fxVarChannelRemove)(FXvariable, FXint ID, FXint flags);

//////////////////
FX_API(FXint, fxVarCopy)(FXchar *fromName, FXchar *toName, FXint withDescendents, FXint flags);	// Copy one Variable in the scene to another (just like the * does)

FX_API(FXvariable, fxVarFind)(FXchar *prefix, FXchar *name, FXint flags); //Find a Variable given its name

FX_API(FXint, fxVarGetName)(FXvariable vID,FXchar *name); //Gets the name of a variable

FX_API(FXvariable, fxVarFirst)(FXint flags);			// Gets the first Variable in the scene
FX_API(FXvariable, fxVarNext )(FXvariable, FXint flags);	// Gets the next Variable in the scene that's after the specified Variable
FX_API(FXvariable, fxVarPrev )(FXvariable, FXint flags);	// Gets the previous Variable in the scene that's before the specified VAriable
FX_API(FXvariable, fxVarParent)(FXvariable, FXint flags);	// Gets the parent of the specified Variable
FX_API(FXint, fxVarSetParent)(FXvariable vID,FXvariable parentID, FXint flags);	// sets the parent of the specified Variable

FX_API(FXvariable, fxVarChildFirst)(FXvariable, FXint flags);	// Gets the first child only of the specified Variable

FX_API(FXint, fxGetVarChannel)(FXvariable, FXint seq, FXobject *obj, FXint *chan, FXint flags);	// Gets the first Obj & Channel attached to a Variable given it's sequence

FX_API(FXint, fxGetVarChanBlendOp)(FXvariable, FXint seq, FXint *blendOp, FXint flags);	// Gets the Blending Operator of the Obj/Channel attached to Variable using it's sequence
FX_API(FXint, fxSetVarChanBlendOp)(FXvariable, FXint seq, FXint blendOp, FXint flags);	// Sets the Blending Operator of the Obj/Channel attached to Variable using it's sequence

FX_API(FXint, fxGetVariableStatus)(FXvariable, FXint *status, FXint flags);		// Gets the Status of a Variable (enabled/disabled)
FX_API(FXint, fxSetVariableStatus)(FXvariable, FXint  status, FXint flags);		// Sets the Status of a Variable (enabled/disabled)

FX_API(FXint, fxGetVariableEvalOrder)(FXvariable, FXint *evalOrder, FXint flags);	// Gets the evaluation Order of the Variable (before /after IK etc)
FX_API(FXint, fxSetVariableEvalOrder)(FXvariable, FXint  evalOrder, FXint flags);	// Sets the Status of a Variable (enabled/disabled)

//////////////

#define _MESSIAH_PTR_VARIABLE	messiah_apicomponent = FX_APIFUNCS_VARIABLE;\
								FX_PTR(fxVarCreate);\
								FX_PTR(fxVarDelete);\
								FX_PTR(fxVarName);\
								FX_PTR(fxVarRename);\
								FX_PTR(fxVarExp);\
								FX_PTR(fxVarExpLength);\
								FX_PTR(fxVarExpSet);\
								FX_PTR(fxVarChannelAdd);\
								FX_PTR(fxVarChannelRemove);\
								FX_PTR(fxVarCopy);\
								FX_PTR(fxVarFind);\
								FX_PTR(fxVarGetName);\
								FX_PTR(fxVarFirst);\
								FX_PTR(fxVarNext);\
								FX_PTR(fxVarPrev);\
								FX_PTR(fxVarParent);\
								FX_PTR(fxVarChildFirst);\
								FX_PTR(fxGetVarChannel);\
								FX_PTR(fxGetVarChanBlendOp);\
								FX_PTR(fxSetVarChanBlendOp);\
								FX_PTR(fxGetVariableStatus);\
								FX_PTR(fxSetVariableStatus);\
								FX_PTR(fxGetVariableEvalOrder);\
								FX_PTR(fxSetVariableEvalOrder);\
								FX_PTR(fxVarSetParent)


#endif //__MESSIAH_VARIABLE



#endif //_MESSIAH_API_VARIABLE


